Attribute VB_Name = "Mod_LoginDatabase"
Public PlayerLogins(1 To 1000) As PLY_LGNS

Private Type PLY_GME_DTA
    CurrentX As Single
    CurrentY As Single
    CurrentZ As Single
    Health As Single
    Skin As Integer
    Rotation As Single
    Money As Long
End Type

Private Type PLY_LGNS
    LoginName As String
    Password As String
    GameData As PLY_GME_DTA
    Admin As Boolean
    Nickname As String
    EmailAddress As String
    Banned As Boolean
    Level As Long
    XP As Long
End Type

Public Sub LoadPlayerLogins()
Dim ff As Integer
Dim Buffer As String
Dim TableBuffer As String
Dim SplitTable() As String
Dim SplitLine() As String
Dim FS As Integer
Dim CF As String 'Current File

    Erase PlayerLogins
    
    If FileExists(App.Path & "\Databases\PlayerLoginDatabase\Table.rpg") = False Then Exit Sub
    
    'Load the table buffer to find the folders etc.
    ff = FreeFile
    Open App.Path & "\Databases\PlayerLoginDatabase\Table.rpg" For Input As #ff
        Do While Not EOF(ff)
            Line Input #ff, Buffer
            If Buffer <> "" Then TableBuffer = TableBuffer & vbNewLine & Buffer
        Loop
    Close #ff
    
    SplitTable = Split(TableBuffer, vbNewLine)
    For i = 1 To UBound(SplitTable)
    
        'Finds a free slot (Find Player Login Slot = FPLS)
        FS = FPLS
        CF = App.Path & "\Databases\PlayerLoginDatabase\Players\" & SplitTable(i) & "\config.ini"
        If FileExists(CF) Then
            If GetFromINI("Server", "Admin", CF) = "True" Then
                PlayerLogins(FS).Admin = True
            Else
                PlayerLogins(FS).Admin = False
            End If
            
            PlayerLogins(FS).LoginName = SplitTable(i)
            PlayerLogins(FS).Nickname = GetFromINI("Player", "Nickname", CF)
            PlayerLogins(FS).Password = GetFromINI("Player", "Password", CF)
            PlayerLogins(FS).GameData.CurrentX = CSng(GetFromINI("Coords", "X", CF))
            PlayerLogins(FS).GameData.CurrentY = CSng(GetFromINI("Coords", "Y", CF))
            PlayerLogins(FS).GameData.CurrentZ = CSng(GetFromINI("Coords", "Z", CF))
            PlayerLogins(FS).GameData.Health = CSng(GetFromINI("Player", "Health", CF))
            PlayerLogins(FS).GameData.Money = CLng(GetFromINI("Money", "Cash", CF))
            PlayerLogins(FS).GameData.Rotation = CSng(GetFromINI("Coords", "R", CF))
            PlayerLogins(FS).GameData.Skin = CInt(GetFromINI("Skin", "ID", CF))
            
            Buffer = GetFromINI("Player", "Level", CF)
            If Buffer = "" Then Buffer = 1
            If Buffer = 0 Then Buffer = 1
            PlayerLogins(FS).Level = CLng(Buffer)
            
            Buffer = GetFromINI("Player", "XP", CF)
            If Buffer = "" Then Buffer = 0
            PlayerLogins(FS).XP = CLng(Buffer)
            
            If LCase(GetFromINI("Player", "Banned", CF)) = "true" Then
                PlayerLogins(FS).Banned = True
            End If
        Else
            FrmServer.AppendConsole "Unable to load profile: " & SplitTable(i) & " [config.ini missing]"
        End If
    Next
    
End Sub

Public Sub SavePlayerLogins(Optional DontSaveBans As Boolean)
Dim i As Integer
Dim CF As String
Dim Buffer As String
Dim ff As Integer

    For i = 1 To 1000
        If PlayerLogins(i).LoginName <> "" Then
            CF = App.Path & "\Databases\PlayerLoginDatabase\Players\" & PlayerLogins(i).LoginName & "\config.ini"
            If FileExists(CF) Then
                'It exists... so update the file
                WriteToINI "Player", "Nickname", PlayerLogins(i).Nickname, CF
                WriteToINI "Player", "Password", PlayerLogins(i).Password, CF
                WriteToINI "Player", "Email", PlayerLogins(i).EmailAddress, CF
                WriteToINI "Player", "Health", CStr(PlayerLogins(i).GameData.Health), CF
                WriteToINI "Money", "Cash", CStr(PlayerLogins(i).GameData.Money), CF
                WriteToINI "Coords", "X", CStr(PlayerLogins(i).GameData.CurrentX), CF
                WriteToINI "Coords", "Y", CStr(PlayerLogins(i).GameData.CurrentY), CF
                WriteToINI "Coords", "Z", CStr(PlayerLogins(i).GameData.CurrentZ), CF
                WriteToINI "Coords", "R", CStr(PlayerLogins(i).GameData.Rotation), CF
                WriteToINI "Skin", "ID", CStr(PlayerLogins(i).GameData.Skin), CF
                WriteToINI "Server", "Admin", CStr(PlayerLogins(i).Admin), CF
                If Not DontSaveBans Then WriteToINI "Player", "Banned", CStr(PlayerLogins(i).Banned), CF
                WriteToINI "Player", "Level", CStr(PlayerLogins(i).Level), CF
                WriteToINI "Player", "XP", CStr(PlayerLogins(i).XP), CF
                'Player saved.
                
            Else
                'It does not exist, but its in the current database... we have to make it
                On Error Resume Next
                MkDir App.Path & "\Databases"
                MkDir App.Path & "\Databases\PlayerLoginDatabase"
                MkDir App.Path & "\Databases\PlayerLoginDatabase\Players\"
                MkDir App.Path & "\Databases\PlayerLoginDatabase\Players\" & PlayerLogins(i).LoginName
                
                WriteToINI "Player", "Nickname", PlayerLogins(i).Nickname, CF
                WriteToINI "Player", "Email", PlayerLogins(i).EmailAddress, CF
                WriteToINI "Player", "Password", PlayerLogins(i).Password, CF
                WriteToINI "Player", "Health", PlayerLogins(i).GameData.Health, CF
                WriteToINI "Money", "Cash", PlayerLogins(i).GameData.Money, CF
                WriteToINI "Coords", "X", PlayerLogins(i).GameData.CurrentX, CF
                WriteToINI "Coords", "Y", PlayerLogins(i).GameData.CurrentY, CF
                WriteToINI "Coords", "Z", PlayerLogins(i).GameData.CurrentZ, CF
                WriteToINI "Coords", "R", PlayerLogins(i).GameData.Rotation, CF
                WriteToINI "Skin", "ID", PlayerLogins(i).GameData.Skin, CF
                WriteToINI "Server", "Admin", CStr(PlayerLogins(i).Admin), CF
                If Not DontSaveBans Then WriteToINI "Player", "Banned", CStr(PlayerLogins(i).Banned), CF
                WriteToINI "Player", "Level", CStr(PlayerLogins(i).Level), CF
                WriteToINI "Player", "XP", CStr(PlayerLogins(i).XP), CF
            End If
            Buffer = Buffer & PlayerLogins(i).LoginName & vbNewLine
        End If
    Next
    
    ff = FreeFile
    Open App.Path & "\Databases\PlayerLoginDatabase\Table.rpg" For Output As #ff
        Print #ff, Buffer
    Close #ff
End Sub

Public Sub CreatePlayerLogin(LoginName As String, Password As String, EmailAddress As String, CharName As String, Optional Admin As Boolean)
Dim FS As Integer

    FS = FPLS
    PlayerLogins(FS).Admin = Admin
    PlayerLogins(FS).LoginName = LoginName
    PlayerLogins(FS).Password = Password
    PlayerLogins(FS).GameData.CurrentX = 0.1
    PlayerLogins(FS).GameData.CurrentY = 0.1
    PlayerLogins(FS).GameData.CurrentZ = 0.1
    PlayerLogins(FS).GameData.Health = 100
    PlayerLogins(FS).GameData.Money = 0
    PlayerLogins(FS).GameData.Rotation = 0
    PlayerLogins(FS).GameData.Skin = 0
    PlayerLogins(FS).EmailAddress = EmailAddress
    PlayerLogins(FS).Nickname = CharName

    SavePlayerLogins
    
End Sub

Public Sub EditPlayerLogin(PName As String, Optional Nickname As String, Optional Health As String, Optional Cash As String, _
                            Optional X As String, Optional Y As String, Optional Z As String, Optional R As String, _
                            Optional SkinID As String, Optional EmailAddress As String, Optional Admin As Boolean)
Dim PlayerID As Integer

    PlayerID = FPLS(PName)
    If Nickname <> "" Then
        PlayerLogins(PlayerID).Nickname = Nickname
    End If
    If Health <> "" Then
        PlayerLogins(PlayerID).GameData.Health = CSng(Health)
    End If
    If Cash <> "" Then
        PlayerLogins(PlayerID).GameData.Money = CLng(Cash)
    End If
    If X <> "" Then
        PlayerLogins(PlayerID).GameData.CurrentX = CSng(X)
    End If
    If Y <> "" Then
        PlayerLogins(PlayerID).GameData.CurrentY = CSng(Y)
    End If
    If Z <> "" Then
        PlayerLogins(PlayerID).GameData.CurrentZ = CSng(Z)
    End If
    If R <> "" Then
        PlayerLogins(PlayerID).GameData.Rotation = CSng(R)
    End If
    If SkinID <> "" Then
        PlayerLogins(PlayerID).GameData.Skin = CInt(SkinID)
    End If
    If EmailAddress <> "" Then
        PlayerLogins(PlayerID).EmailAddress = EmailAddress
    End If
    PlayerLogins(PlayerID).Admin = Admin
    
End Sub

Public Sub RemovePlayerLogin(PlayerName As String)
    'Deletes the user.
    PlayerLogins(FPLS(PlayerName)).LoginName = ""
End Sub

Public Function FPLS(Optional PName As String) As Integer
Dim i As Integer

    If PName <> "" Then
        For i = 1 To UBound(PlayerLogins)
            If PlayerLogins(i).LoginName = PName Then
                FPLS = i
                Exit Function
            End If
        Next
    Else
        For i = 1 To UBound(PlayerLogins)
            If PlayerLogins(i).LoginName = "" Then
                FPLS = i
                Exit Function
            End If
        Next
    End If

End Function

Public Function ProcessPlayerLogin(PName As String, PPass As String, Errors As String) As Boolean
Dim i As Integer
Dim LoggedInFine As Boolean
Dim WrongPassword As Boolean
Dim X As Integer
    
    For i = 1 To 1000
        If PlayerLogins(i).LoginName = PName Then
            If PlayerLogins(i).Password = PPass Then
                LoggedInFine = True
                X = i
                Exit For
            Else
                WrongPassword = True
                Exit For
            End If
        End If
    Next
    
    If Not LoggedInFine And Not WrongPassword Then
        'The account does not exist..., Get the client to make one.
        Errors = "NOACCOUNT"
    End If
    
    If WrongPassword Then
        'Its the wrong passy!
        Errors = "WRONGPASSWORD"
    End If

    If LoggedInFine Then
        'Player has logged in fine... Tell them its alright and wait for the District packet.
        ProcessPlayerLogin = True
        Errors = "NONE"
    End If
End Function

Public Function IsBanned(IP As String) As Boolean
Dim i As Integer

    For i = 1 To 10000
        If BannedData(i).IP <> "" Then
            FrmServer.AppendConsole "Checking Ban " & BannedData(i).IP & " aginst " & IP
            If BannedData(i).IP = IP Then
                IsBanned = True
                Exit Function
            End If
        End If
    Next
End Function
