Attribute VB_Name = "Mod_PlayerDatabase"
Public PlayerStats(1 To 30000) As PlayerStats

Public Type PlayerStats
    PlayerName As String
    Deaths As String
    CarsJacked As String
    OverallScore As String
    ChatMessagesSent As String
    GamesWon As String
    StuntsPreformed As String
    TotalTimePlayed As String
    NumberOfTimesOnServer As String
    LastVehicleUsed As String
    zHighestScoreInOneStunt As String
End Type

Public Sub SavePlayerDatabase()
Dim ff As Integer
Dim i As Integer
Dim StrBuffer As String

    ff = FreeFile
    Open App.Path & "\playerdatabase.dbs" For Output As #ff
        For i = 1 To 30000
            If PlayerStats(i).PlayerName <> "" Then
            
                StrBuffer = ""
                StrBuffer = StrBuffer & PlayerStats(i).CarsJacked & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).ChatMessagesSent & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).Deaths & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).GamesWon & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).LastVehicleUsed & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).NumberOfTimesOnServer & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).OverallScore & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).PlayerName & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).StuntsPreformed & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).TotalTimePlayed & Chr(10)
                StrBuffer = StrBuffer & PlayerStats(i).zHighestScoreInOneStunt
                
                Print #ff, StrBuffer
            End If
        Next
    Close #ff

End Sub

Public Sub LoadPlayerDatabase()
Dim ff As Integer
Dim fds As Integer
Dim SplitData() As String
Dim sLine As String

    If Len(Dir(App.Path & "\playerdatabase.dbs")) = 0 Then Exit Sub

    ff = FreeFile
    Open App.Path & "\playerdatabase.dbs" For Input As #ff
        Do While Not EOF(ff)
            Line Input #ff, sLine
            
            SplitData = Split(sLine, Chr(10))
            If UBound(SplitData) = 10 Then
                fds = FindFreePlayerDatabaseSlot
                PlayerStats(fds).CarsJacked = SplitData(0)
                PlayerStats(fds).ChatMessagesSent = SplitData(1)
                PlayerStats(fds).Deaths = SplitData(2)
                PlayerStats(fds).GamesWon = SplitData(3)
                PlayerStats(fds).LastVehicleUsed = SplitData(4)
                PlayerStats(fds).NumberOfTimesOnServer = SplitData(5)
                PlayerStats(fds).OverallScore = SplitData(6)
                PlayerStats(fds).PlayerName = SplitData(7)
                PlayerStats(fds).StuntsPreformed = SplitData(8)
                PlayerStats(fds).TotalTimePlayed = SplitData(9)
                PlayerStats(fds).zHighestScoreInOneStunt = SplitData(10)
            End If
        Loop
    Close #ff

End Sub

Public Function FindFreePlayerDatabaseSlot() As Integer
Dim i As Integer
    For i = 1 To 30000
        If PlayerStats(i).PlayerName = "" Then
            FindFreePlayerDatabaseSlot = i
            Exit Function
        End If
    Next
End Function

Public Sub SaveNewPlayer(PlayerName As String)
Dim i As Integer
Dim playerFound As Integer
Dim fds As Integer

    For i = 1 To 30000
        If PlayerStats(i).PlayerName = PlayerName Then
            playerFound = i
        End If
    Next
    
    If playerFound = 0 Then
        fds = FindFreePlayerDatabaseSlot
        PlayerStats(fds).PlayerName = PlayerName
        PlayerStats(fds).CarsJacked = 0
        PlayerStats(fds).ChatMessagesSent = 0
        PlayerStats(fds).Deaths = 0
        PlayerStats(fds).GamesWon = 0
        PlayerStats(fds).LastVehicleUsed = "Unknown"
        PlayerStats(fds).NumberOfTimesOnServer = 1
        PlayerStats(fds).OverallScore = 0
        PlayerStats(fds).StuntsPreformed = 0
        PlayerStats(fds).TotalTimePlayed = 0
        PlayerStats(fds).zHighestScoreInOneStunt = 0
    Else
        PlayerStats(playerFound).NumberOfTimesOnServer = (PlayerStats(playerFound).NumberOfTimesOnServer + 1)
    End If
    
End Sub

Public Sub UpdatePlayer(PlayerName As String, Optional Deaths As String, Optional CarsJacked As String, _
                        Optional OverallScore As String, Optional ChatMessages As String, _
                        Optional GamesWon As String, Optional StuntsPreformed As String, _
                        Optional LastVehicleUsed As String, Optional NewHighestScore As String)
Dim i As Integer

    For i = 1 To 30000
        If PlayerStats(i).PlayerName = PlayerName Then
            If Deaths <> "" Then
                PlayerStats(i).Deaths = (PlayerStats(i).Deaths + 1)
            ElseIf CarsJacked <> "" Then
                PlayerStats(i).CarsJacked = (PlayerStats(i).CarsJacked + 1)
            ElseIf OverallScore <> "" Then
                PlayerStats(i).OverallScore = (PlayerStats(i).OverallScore + CLng(OverallScore))
            ElseIf ChatMessages <> "" Then
                PlayerStats(i).ChatMessagesSent = (PlayerStats(i).ChatMessagesSent + CLng(ChatMessages))
            ElseIf GamesWon <> "" Then
                PlayerStats(i).GamesWon = (PlayerStats(i).GamesWon + 1)
            ElseIf StuntsPreformed <> "" Then
                PlayerStats(i).StuntsPreformed = (PlayerStats(i).StuntsPreformed + 1)
            ElseIf LastVehicleUsed <> "" Then
                PlayerStats(i).LastVehicleUsed = LastVehicleUsed
            ElseIf NewHighestScore <> "" Then
                If PlayerStats(i).zHighestScoreInOneStunt = "" Then PlayerStats(i).zHighestScoreInOneStunt = 0
                If CLng(PlayerStats(i).zHighestScoreInOneStunt) < CLng(NewHighestScore) Then PlayerStats(i).zHighestScoreInOneStunt = NewHighestScore
            End If
            Exit Sub
        End If
    Next



End Sub

Public Function ConvertPlayerLoginNameToID(PlayerLogin As String) As Integer
Dim i As Integer
    
    For i = 1 To 30000
        If PlayerLogins(i).LoginName = PlayerLogin Then
            ConvertPlayerLoginNameToID = i
            Exit Function
        End If
    Next

End Function














