Attribute VB_Name = "ScriptSpheres"
'Script Module for creation, deletion and controlling the Sphears
'Script calls:
'   CreateSphere((str)Filename, (str)ProcedureName, (str)SphearName, (float)X, (float)Y, (float)Z, (float)Size)
'   DestroySphere((str)SphereName)
'Script Back-Calls:
'   All functions will have to be made inside the script name given, Example:
'   CreateSphere "code.sad", "Mission1_Begin", MissionBeginSpheresX(0), MissionBeginSpheresY(0), MissionBeginSpheresZ(0),  MissionBeginSpheresR(0)
'   The script code.sad (or its included scripts) MUST include a sub called: "Mission1_Begin"
'   This sub is called whenever the Sphere is touched.

'Define Sphere Type
Private Type SPHERE_TYPE
    X As Single
    Y As Single
    Z As Single
    ProcedureName As String
    Spherename As String
    Filename As String
    Radius As Single
    PlayerID As Integer
End Type

'Make it public
Public ScriptSpheres(1 To 500) As SPHERE_TYPE
Public ScriptSpheresOccupied(1 To 500) As Integer
Public ScriptSpheresOccupiedID(1 To 500) As Integer
Private ScriptSpheresSpawned As Integer

Public Sub CreateSphere(PlayerID As Integer, Filename As String, ProcedureName As String, Spherename As String, X As Single, Y As Single, Z As Single, Radius As Single)
Dim FSS As Integer
    FSS = FindFreeSphereSlot
    ScriptSpheres(FSS).Filename = Filename
    ScriptSpheres(FSS).ProcedureName = ProcedureName
    ScriptSpheres(FSS).Radius = Radius
    ScriptSpheres(FSS).Spherename = Spherename
    ScriptSpheres(FSS).X = X
    ScriptSpheres(FSS).Y = Y
    ScriptSpheres(FSS).Z = Z
    ScriptSpheres(FSS).PlayerID = PlayerID
    ScriptSpheresSpawned = ScriptSpheresSpawned + 1
    'Data:
    '0=SCR 1=SPH 2=CRE 3=X 4=Y 5=Z 6=Radius 7=ServerID
    FrmServer.SendData "SCR" & Chr(10) & "SPH" & Chr(10) & "CRE" & Chr(10) & X & Chr(10) & Y & Chr(10) & Z & Chr(10) & Radius & Chr(10) & FSS, PlayerID, True
End Sub

Public Sub DestroySphere(PlayerID As Integer, Spherename As String)
Dim i As Integer

    For i = 1 To 500
        If ScriptSpheres(i).PlayerID = PlayerID Then
            If ScriptSpheres(i).Spherename = Spherename Then
                ScriptSpheres(i).Spherename = "" 'Totally kills everything in here when next sphere is created
                ScriptSpheresSpawned = ScriptSpheresSpawned - 1
                'Data:
                '0=SCR 1=SPH 2=DES 3=SphID
                FrmServer.SendData "SCR" & Chr(10) & "SPH" & Chr(10) & "DES" & Chr(10) & i, CInt(PlayerID), True
            End If
        End If
    Next
End Sub

Public Sub DestroyPlayerSpheres(PlayerID As Integer)
Dim i As Integer
    For i = 1 To 500
        If ScriptSpheres(i).PlayerID = PlayerID Then
                ScriptSpheres(i).Spherename = "" 'Totally kills everything in here when next sphere is created
                ScriptSpheresSpawned = ScriptSpheresSpawned - 1
        End If
    Next
End Sub

Public Function FindFreeSphereSlot() As Integer
Dim i As Integer
    For i = 1 To 500
        If ScriptSpheres(i).Spherename = "" Then
            FindFreeSphereSlot = i
            Exit For
        End If
    Next
End Function

Public Function GetDistanceBetween2Points(aX As Single, aY As Single, aZ As Single, bX As Single, bY As Single, bZ As Single) As Single
Dim dX As Single
Dim dy As Single
Dim dZ As Single

    dX = (CSng(aX) - CSng(bX))
    dy = (CSng(aY) - CSng(bY))
    dZ = (CSng(aZ) - CSng(bZ))
    
    GetDistanceBetween2Points = Sqr(dX * dX + dy * dy + dZ * dZ)
End Function

Public Sub ScanSpheres()
Dim i As Integer
Dim j As Integer
Dim Distance As Single
Dim VehicleID As Integer
Dim Data(2) As Variant '0 = playerid 1=vehicleid(-1 if no vehicle)
'ScriptSpheresOccupiedID(i) = PlayerID
'ScriptSpheresOccupied(i) = SphereID

    'First scan each maker once, make sure their not "Player Occupied"
    For i = 1 To 500
        DoEvents
        If ScriptSpheres(i).Spherename <> "" Then
            'Scan each player for this marker
            j = ScriptSpheres(i).PlayerID
                If Players(j).Connected Then
                    If Players(j).CurrentPlayerState <> PlayerState_Dead Then
                        If Players(j).CurrentPlayerState = PlayerState_Driving Then
                            Distance = GetDistanceBetween2Points(CSng(ScriptVehicles(Players(j).LastVehicleID).X), CSng(ScriptVehicles(Players(j).LastVehicleID).Y), CSng(ScriptVehicles(Players(j).LastVehicleID).Z), ScriptSpheres(i).X, ScriptSpheres(i).Y, ScriptSpheres(i).Z)
                            VehicleID = Players(j).LastVehicleID
                        ElseIf Players(j).CurrentPlayerState = PlayerState_OnFoot Then
                            Distance = GetDistanceBetween2Points(PlayerLogins(Players(j).ServerID).GameData.CurrentX, PlayerLogins(Players(j).ServerID).GameData.CurrentY, PlayerLogins(Players(j).ServerID).GameData.CurrentZ, ScriptSpheres(i).X, ScriptSpheres(i).Y, ScriptSpheres(i).Z)
                            VehicleID = -1
                        End If
                        
                        If Distance <= (ScriptSpheres(i).Radius - (ScriptSpheres(i).Radius / 2)) And Distance <> 0 Then
                            
                            'Check to make sure the sphereid is the same as the current one, if not... then wrong
                            If Not ScriptSpheresOccupiedID(i) = j Then
                            
                                If Not ScriptSpheresOccupied(i) = i Then
                                    ScriptSpheresOccupiedID(i) = 0
                                    ScriptSpheresOccupied(i) = 0
                                End If
                                
                                'First time inside this sphere?
                                If ScriptSpheresOccupiedID(i) = 0 Then
                                    ScriptSpheresOccupiedID(i) = j
                                    
                                    'Gather data
                                    Data(0) = j
                                    Data(1) = VehicleID
                                    Data(2) = ScriptSpheres(i).Spherename
                                    
                                    'Preform task on script
                                    MyScript.SControl.Modules(ScriptSpheres(i).Filename).Run ScriptSpheres(i).ProcedureName, Data()
                                End If
                            End If
                        Else
                            'if the player got out, then it will return false
                            ScriptSpheresOccupiedID(i) = 0
                        End If
                    Else
                        'Their dead, take them out
                        ScriptSpheresOccupiedID(i) = 0
                    End If
                Else
                    'The player isnt connected any more, destroy sphere
                    DestroySphere ScriptSpheres(i).PlayerID, ScriptSpheres(i).Spherename
                    ScriptSpheresOccupiedID(i) = 0
                End If
        End If
    Next
End Sub

Public Function IsPlayerInSphere(PlayerID As Variant, Spherename As Variant) As Boolean
Dim i As Integer
    
    For i = 1 To 500
        If Spherename = ScriptSpheres(i).Spherename Then
            If CInt(ScriptSpheres(i).PlayerID) = CInt(PlayerID) Then
                IsPlayerInSphere = True
                Exit Function
            End If
        End If
    Next
End Function
